/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package estimation.dataManipulation;

import nervecenter.thesisConstants;

/**
 *
 * @author Stephen P. Ryan
 */
public class stateObservation {

    private String state;
    private String abbreviation;
    private int numberYears = thesisConstants.END_YEAR-thesisConstants.START_YEAR+1;
    private double[] population = new double[numberYears];

    public stateObservation(String line) {
        // line will be state abbreviation, and then a long comma-delimited series of populations, starting in 1998 and going to 1980
        int a = 0;
        int b = line.indexOf(",", a);
        state = line.substring(a, b);
        a = b + 1;

        b = line.indexOf(",", a);
        abbreviation = line.substring(a, b);
        a = b + 1;

        for (int i = 0; i < numberYears-1; i++) {
            b = line.indexOf(",", a);
            population[(numberYears-1)-i] = Double.parseDouble(line.substring(a, b));
            a = b + 1;
        }
        population[0] = Double.parseDouble(line.substring(a));
    }

    public double getPopulation(int year) {
        if(year<thesisConstants.START_YEAR || year>thesisConstants.END_YEAR) {
            System.out.println("Start Year: "+thesisConstants.START_YEAR);
            System.out.println("End Year: "+thesisConstants.END_YEAR);
            System.out.println("Year out of range in stateObservation: "+year);
            System.exit(0);
        }
        return population[year-thesisConstants.START_YEAR];
    }

    /**
     * @return the state
     */
    public String getState() {
        return state;
    }

    /**
     * @return the abbreviation
     */
    public String getAbbreviation() {
        return abbreviation;
    }
}
