/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package estimation.exit;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import optimization.Uncmin_f77;
import optimization.Uncmin_methods;
import utility.pmUtility;

/**
 *
 * @author Stephen P. Ryan
 */
public class estimateExitPolicy implements Uncmin_methods {

    ArrayList<exitDataPoint> data = new ArrayList<exitDataPoint>();
    private double[] exitParameters;

    public estimateExitPolicy() {
    }

    public void execute() {
        prepareData();

        double[] guess = {0, -1.0000619, -0.5952687, -0.0015661, 0.0000456};

        int numParams = 4;
        Uncmin_f77 minimizer = new Uncmin_f77(false);

        double[] xpls = new double[numParams + 1];
        double[] fpls = new double[2];
        double[] gpls = new double[numParams + 1];
        int[] itrmcd = new int[2];
        double[][] a = new double[numParams + 1][numParams + 1];
        double[] udiag = new double[numParams + 1];
        double[] typsiz = new double[numParams + 1];
        double[] fscale = {0, 1E-8};
        int[] method = {0, 1};
        int[] iexp = {0, 1};
        int[] msg = {0, 1};
        int[] ndigit = {0, 7};
        int[] itnlim = {0, 150};
        int[] iagflg = {0, 0};
        int[] iahflg = {0, 0};
        double[] dlt = {0, 1};
        double[] gradtl = {0, 1E-8};
        double[] stepmx = {0, 1E8};
        double[] steptl = {0, 1E-8};

        pmUtility.prettyPrint(new Jama.Matrix(guess, 1));
        minimizer.optif9_f77(numParams, guess, this, typsiz, fscale, method, iexp, msg, ndigit, itnlim, iagflg, iahflg, dlt, gradtl, stepmx, steptl, xpls, fpls, gpls, itrmcd, a, udiag);
        pmUtility.prettyPrint(new Jama.Matrix(guess, 1));

        setExitParameters(new double[5]);
        System.arraycopy(guess, 0, getExitParameters(), 0, 5);
    }

    public double f_to_minimize(double[] x) {
        boolean imposeSignRestrictions = true;
        if(imposeSignRestrictions) {
            x[3] = Math.min(0, x[3]);  // own capacity
            x[4] = Math.max(0, x[4]);  // competitor's capacity
        }
        double llh = 0;
        for(exitDataPoint p : data) {
            llh += p.getLikelihood(x);
        }
        return llh;
    }

    public void gradient(double[] x, double[] g) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void hessian(double[] x, double[][] h) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    private void prepareData() {
        try {
            BufferedReader in = new BufferedReader(new FileReader("data/exit.csv"));
            String line = in.readLine(); // headers
            line = in.readLine(); // first line of data
            while(line!=null) {
                if(line!=null) {
                    // exit,id,name,state,annualCapacity,year,quantity,numFirms,investment,shock,marketQ,dailyCapacity,wage96,coal96,elec96,gas96,population,getCapOtherDouble
                    int a = 0;
                    int b = line.indexOf(",", a);
                    boolean exit = new Boolean(line.substring(a,b));
                    a = b+1;
                    b = line.indexOf(",", a);
                    // id here
                    a = b+1;
                    b = line.indexOf(",", a);
                    // name
                    a = b+1;
                    b = line.indexOf(",", a);
                    // state
                    a = b+1;
                    b = line.indexOf(",", a);
                    double ownCapacity = new Double(line.substring(a,b));
                    a = b+1;
                    b = line.indexOf(",", a);
                    int year = new Integer(line.substring(a,b));
                    int late = 0;
                    if(year>1990) {
                        late = 1;
                    }
                    a = b+1;
                    b = line.indexOf(",", a);
                    // quantity
                    a = b+1;
                    b = line.indexOf(",", a);
                    // numFirms
                    a = b+1;
                    b = line.indexOf(",", a);
                    // investment
                    a = b+1;
                    b = line.indexOf(",", a);
                    // shock
                    a = b+1;
                    b = line.indexOf(",", a);
                    // marketq
                    a = b+1;
                    b = line.indexOf(",", a);
                    // dailycapacity
                    a = b+1;
                    b = line.indexOf(",", a);
                    // wage
                    a = b+1;
                    b = line.indexOf(",", a);
                    // coal
                    a = b+1;
                    b = line.indexOf(",", a);
                    // elec
                    a = b+1;
                    b = line.indexOf(",", a);
                    // gas
                    a = b+1;
                    b = line.indexOf(",", a);
                    // population
                    a = b+1;
                    b = line.indexOf(",", a);
                    double competitorCapacity = new Double(line.substring(a));
                    data.add(new exitDataPoint(exit, ownCapacity, competitorCapacity, late));
                    line = in.readLine();
                }
            }
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * @return the exitParameters
     */
    public double[] getExitParameters() {
        return exitParameters;
    }

    /**
     * @param exitParameters the exitParameters to set
     */
    public void setExitParameters(double[] exitParameters) {
        this.exitParameters = exitParameters;
    }
}
