/*
 * findEntryCosts.java
 *
 * Created on June 15, 2004, 1:21 PM
 */
package estimation.simulateWEntry;

import estimation.dataManipulation.entryPopulation;
import java.util.*;
import java.io.*;
import estimation.simulateW.StateVector;

/**
 *
 * @author  Stephen P. Ryan
 */
public class entryDataPreprocess {

    /** Creates a new instance of findEntryCosts */
    public entryDataPreprocess() {
        System.out.print("Processing entry data...");
        ArrayList<String> outerList = new ArrayList<String>();  // index whether a state has an entry in stateList below
        ArrayList<ArrayList<String>> stateList = new ArrayList<ArrayList<String>>();  // full of lists of strings

        try {
            BufferedReader in = new BufferedReader(new FileReader("data/alldata.csv"));
            String line = in.readLine();
            while (line != null) {
                line = in.readLine();
                if (line != null) {
                    // System.out.println(line);
                    int a = 0;
                    int b = line.indexOf(",", a); // id
                    a = b + 1;
                    b = line.indexOf(",", a); // name
                    a = b + 1;
                    b = line.indexOf(",", a); // region/state
                    String stateAbbr = line.substring(a, b);
                    int index = findString(outerList, stateAbbr);
                    if (index > -1) {
                        // System.out.println(index);
                        ArrayList<String> entryList = (ArrayList<String>) stateList.get(index);
                        entryList.add(line);
                    } else {
                        ArrayList<String> entryList = new ArrayList<String>();
                        entryList.add(line);
                        stateList.add(entryList);
                        outerList.add(stateAbbr);
                    }
                }
            }
            in.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        ArrayList<Boolean> entryList = new ArrayList<Boolean>();  // we'll put boolean in here
        ArrayList<StateVector> stateVectorList = new ArrayList<StateVector>();  // we store the state vector for each market
        for (int i = 0; i < stateList.size(); i++) {
            ArrayList l = (ArrayList) stateList.get(i);
            ArrayList<ArrayList<String>> years = new ArrayList<ArrayList<String>>();
            ArrayList<String> yearIndex = new ArrayList<String>();
            ArrayList<String> regionIndex = new ArrayList<String>();
            ArrayList<ArrayList<String>> omega = new ArrayList<ArrayList<String>>();
            for (int j = 0; j < l.size(); j++) {
                String line = (String) l.get(j);
                if (i == 0) {
                    // System.out.println(line);
                }
                int a = 0;
                int b = line.indexOf(","); // id
                String id = line.substring(a, b);
                a = b + 1;
                b = line.indexOf(",", a);  // company name
                a = b + 1;
                b = line.indexOf(",", a);  // state
                String region = line.substring(a, b);
                // System.out.println(region);
                a = b + 1;
                b = line.indexOf(",", a);  // grinding
                a = b + 1;
                b = line.indexOf(",", a);  // year
                int year = Integer.parseInt(line.substring(a, b));
                String yearString = line.substring(a, b);
                a = b + 1;
                b = line.indexOf(",", a); // quantity
                a = b + 1;
                b = line.indexOf(",", a); // numFirms
                a = b + 1;
                b = line.indexOf(",", a); // investment
                a = b + 1;
                b = line.indexOf(",", a); // shock
                a = b + 1;
                b = line.indexOf(",", a); // marketQ
                a = b + 1;
                b = line.indexOf(",", a); // dailyCap -- want to change this to annual capacity so that it jives with everything else
                String capacity = line.substring(a, b);
                int index = yearIndex.indexOf(yearString);
                if (index > -1) {
                    ArrayList<String> yearData = years.get(index);
                    yearData.add(id);
                    ArrayList<String> omegaData = omega.get(index);
                    omegaData.add(capacity);
                } else {
                    ArrayList<String> yearData = new ArrayList<String>();
                    ArrayList<String> omegaData = new ArrayList<String>();
                    omegaData.add(capacity);
                    yearData.add(id);
                    yearIndex.add(yearString);
                    regionIndex.add(region);
                    omega.add(omegaData);
                    years.add(yearData);
                }
            }
            for (int j = 1; j < years.size(); j++) {
                // System.out.println("---------");
                ArrayList now = years.get(j);
                ArrayList past = years.get(j - 1);
                ArrayList<String> omegaData = omega.get(j - 1);
                String year = yearIndex.get(j - 1);
                String region = regionIndex.get(j - 1);
                // System.out.println(year);
                Jama.Matrix stateVector = new Jama.Matrix(past.size(), 1);
                for (int k = 0; k < past.size(); k++) {
                    stateVector.set(k, 0, Double.parseDouble(omegaData.get(k)));
                }
                // pmUtility.prettyPrintVector(stateVector);
                boolean entry = false;
                for (int k = 0; k < now.size(); k++) {
                    String id = (String) now.get(k);
                    // System.out.println(id);
                    if (past.indexOf(id) < 0) {
                        entry = true;  // this means there is a new id in the list that wasn't there before
                    }
                }
                // System.out.println(entry);
                entryList.add(entry);
                stateVectorList.add(new StateVector(stateVector, Integer.parseInt(year), region));
            }
        }

        Jama.Matrix capOtherList = new Jama.Matrix(stateVectorList.size(), 2);
        ArrayList<String> regionNames = new ArrayList<String>();
        int count = 0;
        for (int i = 0; i < stateVectorList.size(); i++) {
            StateVector sv = stateVectorList.get(i);
            Jama.Matrix stateVector = sv.getState();
            int year = sv.getYear();
            String region = sv.getRegion();
            double capother = 0;
            for (int j = 0; j < stateVector.getRowDimension(); j++) {
                capother += stateVector.get(j, 0);
            }
            capother *= 365.0 / 1000.0;  // convert to ANNUAL max capacity to match the rest of the estimation
            capOtherList.set(count, 0, capother);
            capOtherList.set(count, 1, year);
            regionNames.add(region);
            count++;
        }

        entryPopulation populationLookup = new entryPopulation();

        try {
            BufferedWriter out = new BufferedWriter(new FileWriter("data/probitEntry.csv"));
            out.write("Entry, OtherCap, After 1990, Region, Population, Year\n");
            for (int i = 0; i < entryList.size(); i++) {
                int entry = 0;
                if (((Boolean) entryList.get(i)).booleanValue()) {
                    entry = 1;
                }
                String region = regionNames.get(i);
                double population = 0;
                System.out.println(region);
                for (int j = 0; j <= region.length() - 2; j += 2) {
                    // take the abbreviations two at a time
                    System.out.println((j) + " to " + (j + 2));
                    String stateAbbreviation = region.substring(j, j + 2);
                    System.out.println(stateAbbreviation + " " + capOtherList.get(i, 1));
                    double pop = populationLookup.getPopulation(stateAbbreviation, (int) capOtherList.get(i, 1));
                    System.out.println(pop);
                    population += pop;
                }
                int after1990 = 0;
                if(capOtherList.get(i,1)>=1990) {
                    after1990 = 1;
                }
                out.write(entry + "," + capOtherList.get(i, 0) + "," + after1990 + "," + regionNames.get(i) + "," + population + ","+capOtherList.get(i,1)+"\n");
            }
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("finished");
    }

    public int findString(ArrayList list, String match) {
        int index = -1;
        for (int i = 0; i < list.size(); i++) {
            String s = (String) list.get(i);
            if (s.equalsIgnoreCase(match)) {
                index = i;
            }
        }
        return index;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        entryDataPreprocess go = new entryDataPreprocess();
    }
}
