/*
 * ssrulesMain.java
 *
 * Created on October 31, 2003, 10:23 AM
 */
package estimation.ssrulesLikelihood;

import nervecenter.thesisConstants;
import JSci.maths.statistics.*;
import estimation.dataManipulation.entryPopulation;
import utility.*;
import java.util.*;
import java.io.*;
import optimization.*;
import javax.swing.*;
import estimation.ssrules.plantRecord;

/**e
 *
 * @author  Stephen P. Ryan
 */
public class ssrulesMain implements optimization.Uncmin_methods, mcmc.mcmcFunction {

    int numPeriods = thesisConstants.END_YEAR - thesisConstants.START_YEAR + 1;
    NormalDistribution normal = new NormalDistribution();
    ArrayList<plantRecord> data;
    ArrayList<ArrayList<plantRecord>> properData = new ArrayList<ArrayList<plantRecord>>();
    ArrayList<ArrayList<plantRecord>> bootData;
    investmentParametersContainer policyParams;
    bsplineBasisGenerator b1;
    bsplineBasisGenerator b2;
    bsplineBasisGenerator b3;
    // bsplineBasisGenerator b4;
    // bsplineBasisGenerator b5;
    Jama.Matrix betaTarget, betaBand;
    double cutoff = 0.0;
    JTextArea jt = new JTextAreaAutoscroll();
    boolean useStoredFiles = true;
    private String separateString = "";

    public void go() {
        // estimate ss-rule of investment using data on the target level and the size of the adjustment
        int numParams = betaTarget.getRowDimension() + betaBand.getRowDimension() + 2;
        double[] best = new double[numParams + 1];
        best[numParams - 1] = 1;
        best[numParams] = 1;

        System.exit(0);

        if (useStoredFiles) {
            try {
                System.out.println("Loading parameters from bspline" + separateString + ".dat");
                ObjectInputStream in = new ObjectInputStream(new FileInputStream("data/bspline" + separateString + ".dat"));
                in.readObject();  // b1
                in.readObject();  // b2 (already defined below, so no need to read this in)
                betaBand = (Jama.Matrix) in.readObject();
                System.out.println("Read in betaBand:");
                pmUtility.prettyPrintVector(betaBand);
                betaTarget = (Jama.Matrix) in.readObject();
                System.out.println("Read in betaTarget:");
                pmUtility.prettyPrintVector(betaTarget);
                double varBand = in.readDouble();
                // System.out.println("Read in variance of: "+varBand);
                best[numParams - 1] = varBand;
                System.out.println("Read in variance band: " + best[numParams - 1]);
                double varTarget = in.readDouble();
                best[numParams] = varTarget;
                // System.out.println("Read in variance of: "+varTarget);
                System.out.println("Read in variance target: " + best[numParams]);
                in.close();
            } catch (Exception e) {
                System.out.println("Failed to load parameters.  Using OLS as starting values.");
                // e.printStackTrace();
            }
        }

        JFrame f = new JFrame("Monte Carlo SS");
        f.setBounds(100, 100, 180, 140);
        jt.setEditable(false);
        f.getContentPane().add(new JScrollPane(jt));
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        // f.dispose();
        f.setVisible(true);

        Uncmin_f77 minimizer = new Uncmin_f77(false);

        double[] xpls = new double[numParams + 1];
        double[] fpls = new double[2];
        double[] gpls = new double[numParams + 1];
        int[] itrmcd = new int[2];
        double[][] a = new double[numParams + 1][numParams + 1];
        double[] udiag = new double[numParams + 1];
        double[] typsiz = new double[numParams + 1];
        for (int i = 1; i <= numParams; i++) {
            typsiz[i] = 1;
        }

        double[] fscale = {0, 1E-8};
        int[] method = {0, 1};
        int[] iexp = {0, 1};
        int[] msg = {0, 1};
        int[] ndigit = {0, 7};
        int[] itnlim = {0, 150};
        int[] iagflg = {0, 0};
        int[] iahflg = {0, 0};
        double[] dlt = {0, 1};
        double[] gradtl = {0, 1E-8};
        double[] stepmx = {0, 1E8};
        double[] steptl = {0, 1E-8};

        for (int ij = 0; ij < betaBand.getRowDimension(); ij++) {
            best[ij + 1] = betaBand.get(ij, 0);
        }
        for (int ij = 0; ij < betaTarget.getRowDimension(); ij++) {
            best[ij + 1 + betaBand.getRowDimension()] = betaTarget.get(ij, 0);
        }

        // pmUtility.prettyPrintVector(betaBand);
        // pmUtility.prettyPrintVector(betaTarget);
        for (int i = 0; i < betaBand.getRowDimension(); i++) {
            best[i + 1] = betaBand.get(i, 0);
        }
        for (int i = 0; i < betaTarget.getRowDimension(); i++) {
            best[i + 1 + betaBand.getRowDimension()] = betaTarget.get(i, 0);
        }
        System.out.println("Starting vector of parameters:");
        pmUtility.prettyPrint(new Jama.Matrix(best, 1));
        System.out.println("Maximizing ss-rule likelihood");
        bootData = new ArrayList<ArrayList<plantRecord>>(properData);
//            for (int j = 0; j < properData.size(); j++) {
//                bootData.add(properData.get(j));
//            }
        System.out.println("Pre-likelihood estimates");
        System.out.println("f: " + f_to_minimize(best));
        minimizer.optif9_f77(numParams, best, this, typsiz, fscale, method, iexp, msg, ndigit, itnlim, iagflg, iahflg, dlt, gradtl, stepmx, steptl, xpls, fpls, gpls, itrmcd, a, udiag);
        System.out.println("Post-likelihood estimates");
        System.out.println("f: " + f_to_minimize(best));
        System.out.println("Post-estimation parameters:");
        pmUtility.prettyPrint(new Jama.Matrix(best, 1));

        bootData = new ArrayList<ArrayList<plantRecord>>();
        for (int j = 0; j < properData.size(); j++) {
            bootData.add(properData.get(j));
        }
        printErrors(best);

        for (int i = 0; i < betaTarget.getRowDimension(); i++) {
            betaBand.set(i, 0, best[i + 1]);
            betaTarget.set(i, 0, best[i + 1 + betaTarget.getRowDimension()]);
        }
        System.out.println("Likelihood output to data/bspline" + separateString + ".dat");
        try {
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("data/bspline" + separateString + ".dat"));
            out.writeObject(b1);
            out.writeObject(b2);
            out.writeObject(betaBand);
            System.out.println("Wrote betaBand:");
            pmUtility.prettyPrintVector(betaBand);
            out.writeObject(betaTarget);
            System.out.println("Wrote betaTarget:");
            pmUtility.prettyPrintVector(betaTarget);
            out.writeDouble(best[numParams - 1]);  // variance band
            System.out.println("Wrote variance of " + best[numParams - 1]);
            out.writeDouble(best[numParams]);  // variance target
            System.out.println("Wrote variance of " + best[numParams]);
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        f.dispose();
    }

    public investmentParametersContainer getParameters() {
        return policyParams;
    }

    public ssrulesMain(ArrayList<plantRecord> dataPassed) {
        if (thesisConstants.SEPARATE_POLICY_FUNCTIONS) {
            if (thesisConstants.LATE_PERIOD) {
                separateString = "late";
            } else {
                separateString = "early";
            }
        }
        System.out.println("Entering ssruleMain");
        data = dataPassed;
        processData();
        System.out.println("Data processed.");

        int change = 0;

        cutoff = thesisConstants.INVESTMENT_CUTOFF_LEVEL;

        // can i estimate separate policy functions for early and late period here by just putting in the data from the relevant period?
        // let's try this
        boolean separatePolicyFunctions = thesisConstants.SEPARATE_POLICY_FUNCTIONS;
        if (separatePolicyFunctions) {
            System.out.println("Estimating investment policy functions separately for pre- and post-1990");
        }

        int entryCount = 0;

        double numInvestments = 0;
        double averageDivestmentSize = 0;
        double averageDivestmentPercentage = 0;
        double averageInvestmentSize = 0;
        double averageInvestmentPercentage = 0;
        double numDivestments = 0;
        int entryCountBefore1990 = 0;
        int entryCountAfter1990 = 0;

        for (ArrayList<plantRecord> subdata : properData) {
            for (int j = 1; j < subdata.size(); j++) {
                plantRecord p2 = subdata.get(j);
                plantRecord p1 = subdata.get(j - 1);
                double pct_change = (p2.getAnnualCapacity() - p1.getAnnualCapacity()) / p1.getAnnualCapacity();
                // double abs_change = Math.abs(p2.getAnnualCapacity()-p1.getAnnualCapacity());
                boolean qualified = true;
                if (separatePolicyFunctions) {
                    qualified = false;
                    if (thesisConstants.LATE_PERIOD && p1.getYear() >= 1990) {
                        qualified = true;
                    }
                    if (!thesisConstants.LATE_PERIOD && p1.getYear() < 1990) {
                        qualified = true;
                    }
                }
                if (Math.abs(pct_change) > cutoff && qualified) {
                    change++;
                    if(pct_change>0) {
                        averageDivestmentSize -= (p2.getAnnualCapacity()-p1.getAnnualCapacity());
                        averageDivestmentPercentage += pct_change;
                        numDivestments++;
                    } else {
                        numInvestments++;
                        averageInvestmentSize += (p2.getAnnualCapacity()-p1.getAnnualCapacity());
                        averageInvestmentPercentage += pct_change;
                    }
                }
                if (j == 1 && subdata.get(0).getYear() > thesisConstants.START_YEAR && qualified) {
                    // this guy enters some time during the sample
                    change++;
                    entryCount++;
                    if(subdata.get(0).getYear()<1990) {
                        entryCountBefore1990++;
                    } else {
                        entryCountAfter1990++;
                    }
                }
            }
        }

        averageDivestmentSize /= numDivestments;
        averageDivestmentPercentage /= numDivestments;
        averageInvestmentSize /= numInvestments;
        averageInvestmentPercentage /= numInvestments;

        System.out.println("Tabulated " + entryCount + " entries.");
        System.out.println("\tBefore 1990: "+entryCountBefore1990);
        System.out.println("\tAfter 1990: "+entryCountAfter1990);

        System.out.println("Cutoff: " + cutoff + " Number of capacity changes: " + change);
        System.out.println("\tNumber Investments: "+numInvestments);
        System.out.println("\tAverage Investment: "+averageInvestmentSize);
        System.out.println("\tAverage Investment Pct Change: "+averageInvestmentPercentage);
        System.out.println("\tNumber Divestments: "+numDivestments);
        System.out.println("\tAverage Divestment: "+averageDivestmentSize);
        System.out.println("\tAverage Divestment Pct Change: "+averageDivestmentPercentage);
        
        int numExplanatoryVariables = 2;

        boolean perCapitaSpecification = false;

        Jama.Matrix stackedTarget = new Jama.Matrix(change, 1);
        Jama.Matrix stackedExplanatory = new Jama.Matrix(change, numExplanatoryVariables);
        Jama.Matrix stackedBand = new Jama.Matrix(change, 1);
        Jama.Matrix population = new Jama.Matrix(change, 1);
        ArrayList<String> stateList = new ArrayList<String>();
        ArrayList<Integer> yearList = new ArrayList<Integer>();

        int stackCount = 0;
        entryCount = 0;
        /**
         * Now recall that properData contains lists of plantRecords in runs
         * that accord with a specific plant state-zip identifier.
         */
        for (int i = 0; i < properData.size(); i++) {
            ArrayList<plantRecord> subdata = properData.get(i);
            /**
             * Loop through the list of plantrecords, starting at t=1
             * because we have to get t-1 in order to figure out how much
             * the capacity changed.
             */
            // System.out.println("Evaluating: " + subdata.get(0).getID());
            for (int j = 1; j < subdata.size(); j++) {
                plantRecord p2 = subdata.get(j);
                plantRecord p1 = subdata.get(j - 1);
                double pct_change = (p2.getAnnualCapacity() - p1.getAnnualCapacity()) / p1.getAnnualCapacity();
                boolean qualified = true;
                if (separatePolicyFunctions) {
                    qualified = false;
                    if (thesisConstants.LATE_PERIOD && p1.getYear() >= 1990) {
                        qualified = true;
                    }
                    if (!thesisConstants.LATE_PERIOD && p1.getYear() < 1990) {
                        qualified = true;
                    }
                }
                if (Math.abs(pct_change) > cutoff && qualified) {
                    stateList.add(p2.getState());
                    yearList.add(p1.getYear());
                    // System.out.println("Market capacities:");
                    // pmUtility.prettyPrintVector(p1.getMarketCapacityMatrix());
                    // System.out.println("Own: " + p1.getAnnualCapacity() + " Other: " + p1.getCapOtherDouble());
                    if (p1.getAnnualCapacity() == p1.getCapOtherDouble()) {
                        // System.out.println("***************** EQUAL *****************");
                    }
                    // *********************** This is where I construct the matrix of regressors in the main regression!
                    if (perCapitaSpecification) {
                        stackedExplanatory.set(stackCount, 0, 1e7 * p1.getCapOtherDouble() / p1.getPopulation());
                        stackedExplanatory.set(stackCount, 1, 1e7 * p1.getAnnualCapacity() / p1.getPopulation());
                    } else {
                        stackedExplanatory.set(stackCount, 0, p1.getCapOtherDouble());
                        stackedExplanatory.set(stackCount, 1, p1.getAnnualCapacity());
                        // stackedExplanatory.set(stackCount, 2, p1.getPopulation());
                    }
                    population.set(stackCount, 0, p1.getPopulation() / 1e7);

                    // stackedTarget.set(stackCount, 0, p2.getAnnualCapacity());
                    stackedTarget.set(stackCount, 0, Math.log(p2.getAnnualCapacity()));
                    stackedBand.set(stackCount, 0, Math.log(Math.abs(p2.getAnnualCapacity() - p1.getAnnualCapacity())));
                    stackCount++;
                }
                if (j == 1 && p1.getYear() > thesisConstants.START_YEAR && qualified) {
                    stateList.add(p1.getState());
                    yearList.add(p1.getYear());
                    // this is considered an entrant in the data
                    entryCount++;
                    if (perCapitaSpecification) {
                        stackedExplanatory.set(stackCount, 0, 1e7 * p1.getCapOtherDouble() / p1.getPopulation());
                        stackedExplanatory.set(stackCount, 1, 0);
                    } else {
                        stackedExplanatory.set(stackCount, 0, p1.getCapOtherDouble());
                        stackedExplanatory.set(stackCount, 1, 0);
                        // stackedExplanatory.set(stackCount, 2, p1.getPopulation());
                    }
                    population.set(stackCount, 0, p1.getPopulation() / 1e7);

                    // stackedTarget.set(stackCount, 0, p2.getAnnualCapacity());
                    stackedTarget.set(stackCount, 0, Math.log(p1.getAnnualCapacity()));
                    stackedBand.set(stackCount, 0, Math.log(p1.getAnnualCapacity()));
                    stackCount++;
                }
            }
        }

        // run bspline regressions here to confirm what splus finds
        Jama.Matrix capother = pmUtility.getColumn(stackedExplanatory, 0);
        Jama.Matrix owncap = pmUtility.getColumn(stackedExplanatory, 1);

        b1 = new bsplineBasisGenerator(0, 12638, 4); // largest sum competitor capacity is 12638
        b2 = new bsplineBasisGenerator(0, 2500, 4);  // largest firm is 2354

        Jama.Matrix basisX = b1.getBasisMatrix(capother);
        basisX = pmUtility.concatMatrixLOO(basisX, b2.getBasisMatrix(owncap));

        boolean usePopulation = false;

        if (!perCapitaSpecification) {
            b3 = new bsplineBasisGenerator(0, 3);  // max population is 2.99 (29 million)
            if (usePopulation) {
                basisX = pmUtility.concatMatrixLOO(basisX, b3.getBasisMatrix(population));
            }
        }

        // pmUtility.prettyPrint(pmUtility.concatMatrix(stackedBand, basisX));
        betaBand = pmUtility.OLSsvd(basisX, stackedBand, false);
        System.out.println("OLS estimate for band equation:");
        pmUtility.prettyPrintVector(betaBand);
        Jama.Matrix bandFit = basisX.times(betaBand);
        Jama.Matrix bandError = stackedBand.minus(bandFit);
        double varianceBandEquation = 0;
        for (int i = 0; i < bandFit.getRowDimension(); i++) {
            varianceBandEquation += bandError.get(i, 0) * bandError.get(i, 0);
        }
        varianceBandEquation /= (bandFit.getRowDimension() + betaBand.getColumnDimension());
        System.out.println("Estimated variance of error term in band: " + varianceBandEquation);
        // thesisConstants.INVESTMENT_BAND_MEANS = betaBand;
        // thesisConstants.INVESTMENT_BAND_VARIANCES = pmUtility.getOLSVariances(stackedBand, basisX, false);
        // System.out.println("Estimated variances for band equation:");
        // pmUtility.prettyPrintVector(thesisConstants.INVESTMENT_BAND_VARIANCES);

        // pmUtility.prettyPrint(pmUtility.concatMatrix(stackedTarget, basisX));
        betaTarget = pmUtility.OLSsvd(basisX, stackedTarget, false);
        /**
         * Need to implement caps on these numbers, since otherwise they can
         * give economically infeasible outcomes due to collinearity in the
         * OLS regression (first coefficient = 11, for example, while everything
         * else is near 7, as it should be).  Cap at the maximum firm size seen
         * in the data, ln(2354) = 7.76.
         */
        boolean useKNITROCaps = true;
        if (useKNITROCaps) {
            // pmUtility.prettyPrintVector(betaTarget);
            SolveTargetKNITRO nitroSolver = new SolveTargetKNITRO(basisX, stackedTarget);
            betaTarget = nitroSolver.solveUsingKNitro();
            // pmUtility.prettyPrintVector(betaTarget);
            // System.exit(0);
        }

        System.out.println("OLS estimate for target equation:");
        pmUtility.prettyPrintVector(betaTarget);
        boolean test = true;
        if (test) {
            pmUtility.prettyPrint(b1.getBasis(0));
            pmUtility.prettyPrint(b2.getBasis(0));
            double target0_0 = pmUtility.concatMatrixLOO(b1.getBasis(0), b2.getBasis(0)).times(betaTarget).get(0, 0);
            double target250_0 = pmUtility.concatMatrixLOO(b1.getBasis(0), b2.getBasis(250)).times(betaTarget).get(0, 0);
            double target0_250 = pmUtility.concatMatrixLOO(b1.getBasis(250), b2.getBasis(0)).times(betaTarget).get(0, 0);
            System.out.println("Target for (0,0): " + target0_0 + " exp(target): " + Math.exp(target0_0));
            System.out.println("Target for (250,0): " + target250_0 + " exp(target): " + Math.exp(target250_0));
            System.out.println("Target for (0,250): " + target0_250 + " exp(target): " + Math.exp(target0_250));
        }
        Jama.Matrix targetFit = basisX.times(betaTarget);
        Jama.Matrix targetError = stackedTarget.minus(targetFit);
        // pmUtility.prettyPrint(pmUtility.concatMatrix(pmUtility.concatMatrix(stackedTarget, targetFit), stackedExplanatory));
        // pmUtility.prettyPrint(pmUtility.concatMatrix(pmUtility.concatMatrix(stackedTarget, targetFit), basisX));
        // System.exit(0);

        double varianceTargetEquation = 0;
        for (int i = 0; i < targetFit.getRowDimension(); i++) {
            varianceTargetEquation += targetError.get(i, 0) * targetError.get(i, 0);
        }
        varianceTargetEquation /= (targetFit.getRowDimension() + betaTarget.getColumnDimension());
//        System.out.println("Estimated variance of error term in target: " + varianceTargetEquation);
//        Jama.Matrix targetVariances = pmUtility.getOLSVariances(stackedTarget, basisX, false);
//        System.out.println("Estimated variances for target equation:");
//        pmUtility.prettyPrintVector(targetVariances);
//        thesisConstants.INVESTMENT_TARGET_MEANS = betaTarget;
//        thesisConstants.INVESTMENT_TARGET_VARIANCES = targetVariances;

        System.out.println("Dimension betaBand: " + betaBand.getRowDimension());
        System.out.println("Dimension betaTarget: " + betaTarget.getRowDimension());

        String perCapitaIndicator = "";
        if (perCapitaSpecification) {
            perCapitaIndicator = "perCapita";
        }

        // pmUtility.prettyPrint(basisX);
        System.out.println("**** Relevant investment CSV files are data/ssRuleBand" + perCapitaIndicator + ".csv and data/ssRuleTarget" + perCapitaIndicator + ".csv");
        try {
            BufferedWriter outBand = new BufferedWriter(new FileWriter("data/ssRuleBand" + perCapitaIndicator + ".csv"));
            BufferedWriter outTarget = new BufferedWriter(new FileWriter("data/ssRuleTarget" + perCapitaIndicator + ".csv"));

            if (perCapitaSpecification) {
                String pString = "";
                for (int i = 0; i < b1.NUM_INTERIOR_KNOTS + 4; i++) {
                    pString = pString + "pcomp" + (i + 1) + ",";
                }
                for (int i = 0; i < b2.NUM_INTERIOR_KNOTS + 4 - 1; i++) {
                    pString = pString + "pown" + (i + 1) + ",";
                }
                outBand.write("year,state,logChange,sumComp,annualOwn,regionPopulation," + pString + "\n");
                outTarget.write("year,state,target,sumComp,annualOwn,regionPopulation," + pString + "\n");
            } else {
                String pString = "";
                for (int i = 0; i < b1.NUM_INTERIOR_KNOTS + 4; i++) {
                    pString = pString + "comp" + (i + 1) + ",";
                }
                for (int i = 0; i < b2.NUM_INTERIOR_KNOTS + 4 - 1; i++) {
                    pString = pString + "own" + (i + 1);
                    if (i < b2.NUM_INTERIOR_KNOTS + 4 - 2) {
                        pString = pString + ",";
                    }
                }
                if (usePopulation) {
                    pString = pString + ",";
                    for (int i = 0; i < b3.NUM_INTERIOR_KNOTS + 4 - 1; i++) {
                        pString = pString + "pop" + (i + 1);
                        if (i < b3.NUM_INTERIOR_KNOTS + 4 - 2) {
                            pString = pString + ",";
                        }
                    }
                }
                outBand.write("year,state,logChange,sumComp,annualOwn,regionPopulation," + pString + "\n");
                outTarget.write("year,state,target,sumComp,annualOwn,regionPopulation," + pString + "\n");
            }

            for (int i = 0; i < basisX.getRowDimension(); i++) {
                outBand.write(yearList.get(i) + "," + stateList.get(i) + "," + stackedBand.get(i, 0) + "," + capother.get(i, 0) + "," + owncap.get(i, 0) + "," + population.get(i, 0) + ",");
                outTarget.write(yearList.get(i) + "," + stateList.get(i) + "," + stackedTarget.get(i, 0) + "," + capother.get(i, 0) + "," + owncap.get(i, 0) + "," + population.get(i, 0) + ",");
                for (int j = 0; j < basisX.getColumnDimension(); j++) {
                    outBand.write(basisX.get(i, j) + "");
                    outTarget.write(basisX.get(i, j) + "");
                    if (j < basisX.getColumnDimension() - 1) {
                        outBand.write(",");
                        outTarget.write(",");
                    }
                }
                outBand.write("\n");
                outTarget.write("\n");
            }
            outBand.close();
            outTarget.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

        // going to just use the OLS estimates (they fit awesomely!)
        // System.out.println("Running the full GMM estimator");

        boolean useLikelihoodEstimator = false;

        if (!useLikelihoodEstimator) {
            System.out.print("Writing OLS results to data/bspline" + separateString + ".dat...");
            try {
                ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("data/bspline" + separateString + ".dat"));
                out.writeObject(b1);
                out.writeObject(b2);
                out.writeObject(betaBand);
                out.writeObject(betaTarget);
                // hand-coded from Stata regressions (see paper)
                out.writeDouble(varianceBandEquation);  // variance band
                out.writeDouble(varianceTargetEquation);  // variance target
                out.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
            System.out.println("done.");
        } else {
            // **** Remove this comment when GMM is back running after OLS worked out ****
            System.out.println("**** Likelihood estimator ****");
            go();  // run full gmm estimator
        }


        /**
         * Store results in container object.
         */
        policyParams = new investmentParametersContainer(b1, b2, betaBand, betaTarget, varianceBandEquation, varianceTargetEquation);

        System.out.println("Finished running ssrule estimation.");
        // System.exit(0);
    }

    public void printErrors(double[] x) {
        try {
            BufferedWriter bandOut = new BufferedWriter(new FileWriter("data/bandFits.csv"));
            BufferedWriter targetOut = new BufferedWriter(new FileWriter("data/targetFits.csv"));
            BufferedWriter changesOut = new BufferedWriter(new FileWriter("data/changes.csv"));
            targetOut.write("Actual Capacity, Predicted Capacity\n");
            bandOut.write("Actual band, Predicted Band\n");
            Jama.Matrix band = new Jama.Matrix(betaBand.getRowDimension(), 1);
            Jama.Matrix target = new Jama.Matrix(betaBand.getRowDimension(), 1);
            for (int i = 1; i <= betaBand.getRowDimension(); i++) {
                band.set(i - 1, 0, x[i]);
                target.set(i - 1, 0, x[i + betaBand.getRowDimension()]);
            }
            double value = 0;
            double numObs = 0;
            int pchange = 0;
            for (int i = 0; i < properData.size(); i++) {
                ArrayList<plantRecord> subdata = properData.get(i);
                for (int j = 1; j < subdata.size(); j++) {
                    numObs++;
                    plantRecord p2 = subdata.get(j);
                    plantRecord p1 = subdata.get(j - 1);

                    changesOut.write((p2.getAnnualCapacity() - p1.getAnnualCapacity()) + "\n");

                    Jama.Matrix predictorX = b1.getBasis(p1.getCapOtherDouble());
                    predictorX = pmUtility.concatMatrixLOO(predictorX, b2.getBasis(p1.getAnnualCapacity()));
                    // predictorX = pmUtility.concatMatrix(predictorX, new Jama.Matrix(1, 1, p1.getShock()));

                    double predictBand = Math.exp(predictorX.times(band).get(0, 0) + 0.5 * x[x.length - 2]);
                    double currentZ = p1.getAnnualCapacity();
                    double targetZ = predictorX.times(target).get(0, 0);
                    double predictZ = currentZ;
                    if (currentZ > targetZ + predictBand) {
                        predictZ = targetZ;
                        pchange++;
                    }
                    if (currentZ < targetZ - predictBand) {
                        predictZ = targetZ;
                        pchange++;
                    }
                    targetOut.write(p2.getAnnualCapacity() + "," + predictZ + "\n");
                    if (Math.abs(p2.getAnnualCapacity() - currentZ) > 0) {
                        bandOut.write(Math.abs(p2.getAnnualCapacity() - currentZ) + "," + predictBand + "\n");
                    }
                    double error = Math.pow(predictZ - p2.getAnnualCapacity(), 2);
                    value += error;
                    // jt.append("current: "+currentZ+" p-band: "+predictBand+" p-target: "+targetZ+" p-next: "+predictZ+" actual: "+p2.getAnnualCapacity()+" error: "+error+"\n");
                }
            }
            value /= numObs;
            jt.append("Error: " + value + " predicted changes: " + pchange + "\n");
            targetOut.close();
            bandOut.close();
            changesOut.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public double f_to_minimize(double[] x) {
        Jama.Matrix band = new Jama.Matrix(betaBand.getRowDimension(), 1);
        Jama.Matrix target = new Jama.Matrix(betaBand.getRowDimension(), 1);
        for (int i = 1; i <= betaBand.getRowDimension(); i++) {
            band.set(i - 1, 0, x[i]);
            target.set(i - 1, 0, x[i + betaBand.getRowDimension()]);
        }
        JSci.maths.statistics.NormalDistribution bnormal = new JSci.maths.statistics.NormalDistribution(0, Math.max(1E-15, x[x.length - 2]));
        JSci.maths.statistics.NormalDistribution tnormal = new JSci.maths.statistics.NormalDistribution(0, Math.max(1E-15, x[x.length - 1]));
        double value = 0;
        double numObs = 0;

        // it appears i'm not censoring anything here
        // what the heck is going on with this?!?

        for (int i = 0; i < bootData.size(); i++) {
            ArrayList<plantRecord> subdata = bootData.get(i);
            for (int j = 1; j < subdata.size(); j++) {
                numObs++;
                plantRecord p2 = subdata.get(j);
                plantRecord p1 = subdata.get(j - 1);

                double pct_change = (p2.getAnnualCapacity() - p1.getAnnualCapacity()) / p1.getAnnualCapacity();

                boolean qualified = true;
                if (thesisConstants.SEPARATE_POLICY_FUNCTIONS) {
                    qualified = false;
                    if (thesisConstants.LATE_PERIOD && p1.getYear() >= 1990) {
                        qualified = true;
                    }
                    if (!thesisConstants.LATE_PERIOD && p1.getYear() < 1990) {
                        qualified = true;
                    }
                }

                Jama.Matrix predictorX = b1.getBasis(p1.getCapOtherDouble());
                predictorX = pmUtility.concatMatrixLOO(predictorX, b2.getBasis(p1.getAnnualCapacity()));

                double z0 = p1.getAnnualCapacity();
                double z1 = p2.getAnnualCapacity();
                double gap = Math.abs(z1 - z0);
                if (Math.abs(pct_change) < cutoff) {
                    // this implies that the change should be set to zero since i call it noise!
                    gap = 0;
                }
                // System.out.println(predictorX.getRowDimension()+" "+predictorX.getColumnDimension()+" "+band.getRowDimension()+" "+band.getColumnDimension());
                double predictedGap = predictorX.times(band).get(0, 0);
                double predictedTarget = predictorX.times(target).get(0, 0);
                if (gap != 0) {
                    double probTarget = tnormal.probability(Math.log(z1) - predictedTarget);
                    double probBand = bnormal.probability(Math.log(gap) - predictedGap);
                    // System.out.println(probTarget+" "+probBand);
                    if (qualified) {
                        value += Math.log(Math.max(1E-15, probTarget * probBand));
                    }
                } else {
                    double[] xh = {3.436159118, 2.532731674, 1.756683649, 1.036610829, 0.3429013272};
                    double[] wh = {0.7640432855E-5, 0.1343645746E-2, .3387439445E-1, 0.2401386110, 0.6108626337};
                    double evh = 0;
                    for (int im = 0; im < 5; im++) {
                        double pointRight = Math.sqrt(2.0 * x[x.length - 2]) * xh[im];
                        double pointLeft = -Math.sqrt(2.0 * x[x.length - 2]) * xh[im];
                        double lowerIntBound = z1 - Math.exp(predictedGap + pointRight) - predictedTarget;
                        double upperIntBound = z1 + Math.exp(predictedGap + pointRight) - predictedTarget;
                        double ival = tnormal.cumulative(upperIntBound) - tnormal.cumulative(lowerIntBound);
                        double lowerIntBound2 = z1 - Math.exp(predictedGap + pointLeft) - predictedTarget;
                        double upperIntBound2 = z1 + Math.exp(predictedGap + pointLeft) - predictedTarget;
                        double ival2 = tnormal.cumulative(upperIntBound2) - tnormal.cumulative(lowerIntBound2);
                        evh += wh[im] * (ival + ival2);
                    }
                    evh /= Math.sqrt(Math.PI);
                    if (qualified) {
                        value += Math.log(Math.max(1E-15, evh));
                    }
                }
            }

            // add entries to investment data--this has to push down the costs since we see new firms making huge initial investments
            plantRecord firstRecord = subdata.get(0);
            if (firstRecord.getYear() != thesisConstants.START_YEAR) {
                // this means there was an entry
                numObs++;

                Jama.Matrix predictorX = b1.getBasis(firstRecord.getCapOtherDouble());
                predictorX = pmUtility.concatMatrixLOO(predictorX, b2.getBasis(0));

                double z0 = 0;
                double z1 = firstRecord.getAnnualCapacity();
                double gap = Math.abs(z1 - z0);
                // System.out.println(predictorX.getRowDimension()+" "+predictorX.getColumnDimension()+" "+band.getRowDimension()+" "+band.getColumnDimension());
                double predictedGap = predictorX.times(band).get(0, 0);
                double predictedTarget = predictorX.times(target).get(0, 0);

                double probTarget = tnormal.probability(Math.log(z1) - predictedTarget);
                double probBand = bnormal.probability(Math.log(gap) - predictedGap);

                boolean qualified = true;
                if (thesisConstants.SEPARATE_POLICY_FUNCTIONS) {
                    qualified = false;
                    if (thesisConstants.LATE_PERIOD && firstRecord.getYear() >= 1990) {
                        qualified = true;
                    }
                    if (!thesisConstants.LATE_PERIOD && firstRecord.getYear() < 1990) {
                        qualified = true;
                    }
                }
                if (qualified) {
                    value += Math.log(Math.max(1E-15, probTarget * probBand));
                }
            }
        }
        value /= numObs;
        // jt.append((-value)+" "+pmUtility.stringPrettyPrint(new Jama.Matrix(x, 1))+"\n");
        if (Double.isInfinite(value)) {
            return 1E100;
        }
        if (Double.isNaN(value)) {
            return 1E100;
        }
        return -value;
    }

    public void gradient(double[] x, double[] g) {
    }

    public void hessian(double[] x, double[][] h) {
    }

    public double objectiveFunction(double[] x) {
        return -f_to_minimize(x);
    }

    public double pi(double[] x) {
        return 1;
    }

    public void processData() {
        try {
            // add population to the plantRecords at this point
            // actually this should be useful down the road for adding population to the investment policy functions as well
            entryPopulation ep = new entryPopulation();
            for (plantRecord p : data) {
                // System.out.println(p);
                double population = 0;
                String state = p.getState();
                for (int i = 0; i < state.length(); i += 2) {
                    population += ep.getPopulation(state.substring(i, i + 2), p.getYear());
                }
                p.setPopulation(population);
            }


            BufferedWriter outExit = new BufferedWriter(new FileWriter("data/exit.csv"));
            BufferedWriter outEntry = new BufferedWriter(new FileWriter("data/entry.csv"));
            BufferedWriter outAll = new BufferedWriter(new FileWriter("data/alldata.csv"));
            outAll.write("id,name,state,annualCapacity,year,quantity,numFirms,investment,shock,marketQ,dailyCapacity,wage96,coal96,elec96,gas96,population,getCapOtherDouble\n");
            outExit.write("exit,id,name,state,annualCapacity,year,quantity,numFirms,investment,shock,marketQ,dailyCapacity,wage96,coal96,elec96,gas96,population,getCapOtherDouble\n");
            outEntry.write("entry,id,name,state,annualCapacity,year,quantity,numFirms,investment,shock,marketQ,dailyCapacity,wage96,coal96,elec96,gas96,population,getCapOtherDouble\n");
            TreeSet<String> tree = new TreeSet<String>();
            /**
             * Q. What does the plant ID look like?
             * A. A state-ZIP combination
             */
            for (plantRecord p : data) {
                // System.out.println(p.getID());
                tree.add(p.getID());
            }
            /**
             * So by adding all the state-zip combinations to the Tree, we can
             * elucidate the set of potential investments that we need to
             * figure out.
             */
            int exitBefore1990 = 0;
            int exitAfter1990 = 0;

            ArrayList<String> idlist = new ArrayList<String>(tree);
            for (int i = 0; i < idlist.size(); i++) {
                String matchID = idlist.get(i);
                /**
                 * Firm array is going to hold copies of all records of each
                 * plant, as defined by the state-zip identifier.
                 */
                ArrayList<plantRecord> firmArray = new ArrayList<plantRecord>();
                for (plantRecord p : data) {
                    if (p.getID().compareTo(matchID) == 0) {
                        firmArray.add(p.deepCopy());
                    }
                }
                /**
                 * properData is a list that holds all of these records
                 * together.
                 */
                properData.add(firmArray);
                for (int c = 0; c < firmArray.size(); c++) {
                    outAll.write(firmArray.get(c) + "\n");
                }
                if (firmArray.size() == numPeriods) {
                    for (int c = 0; c < firmArray.size(); c++) {
                        outEntry.write(0 + "," + firmArray.get(c) + "\n");
                        outExit.write(0 + "," + firmArray.get(c) + "\n");
                    }
                } else {
                    // here is where I can figure out the entry and exit stuff, since these are the firms that are not
                    // in the panel for the full sample
                    for (int c = 0; c < firmArray.size() - 1; c++) {
                        // find spells here by determining the starting year and then checking to see if each
                        // successive year is in order
                        int year = (firmArray.get(c)).getYear();
                        int nextYear = (firmArray.get(c + 1)).getYear();
                        if ((nextYear - year) == 1) {
                            outExit.write(0 + "," + firmArray.get(c) + "\n");
                        } else {
                            if(year<1990) {
                                exitBefore1990++;
                            } else {
                                exitAfter1990++;
                            }
                            outExit.write(1 + "," + firmArray.get(c) + "\n");
                        }
                    }
                    int year = (firmArray.get(firmArray.size() - 1)).getYear();
                    if (year != thesisConstants.END_YEAR) {
                        outExit.write(1 + "," + firmArray.get(firmArray.size() - 1) + "\n");
                    } else {
                        outExit.write(0 + "," + firmArray.get(firmArray.size() - 1) + "\n");
                    }
                    plantRecord p0 = firmArray.get(0);
                    plantRecord p1 = firmArray.get(firmArray.size() - 1);
                    if (p0.getYear() != thesisConstants.START_YEAR) {
                        // entry observation (first)
                        // System.out.println("entry,"+p0);
                        outEntry.write(1 + "," + p0 + "\n");
                        for (int c = 1; c < firmArray.size(); c++) {
                            outEntry.write(0 + "," + firmArray.get(c) + "\n");
                        }
                    }
                }
            }

            outExit.close();
            outEntry.close();
            outAll.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("size of investment data: " + properData.size());
        // System.exit(0);
    }
}
