/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package nervecenter;

import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Stephen P. Ryan
 */
class CementTableModel extends DefaultTableModel {

    static public int DEMAND_PRODUCTION = 1;
    static public int DYNAMIC = 2;

    private int model;

    String[] columnNamesDemand = {"Intercept", "Slope", "Capacity Cost", "Binding Level", "Marginal Cost"};
    String[] columnNamesDynamic = {"Investment MC", "Investment Mu", "Investment Sigma", "Divestment Mu", "Divestment Sigma", "Exit Mu", "Exit Sigma", "Entry Mu Early", "Entry Sigma Early", "Entry Mu Late", "Entry Sigma Late"};

    public CementTableModel(int numBoots, int model) {
        this.model = model;
        setRowCount(numBoots);
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return Double.class;
    }

    @Override
    public int getColumnCount() {
        if(model==DEMAND_PRODUCTION) {
            return columnNamesDemand.length;
        }
        return columnNamesDynamic.length;
    }

    @Override
    public String getColumnName(int column) {
        if(model==DEMAND_PRODUCTION) {
            return columnNamesDemand[column];
        }
        return columnNamesDynamic[column];
    }

}
