/*
 * thesisConstants.java
 *
 * Created on February 21, 2004, 5:04 PM
 */
package nervecenter;

/**
 *
 * @author  Stephen P. Ryan
 */
public class thesisConstants {

    public static double DISCOUNT_FACTOR = 0.9;  // positive discount rate for future periods
    public static int NUM_THREADS = 3;
    public static boolean LATE_PERIOD = true;
    public static boolean SEPARATE_POLICY_FUNCTIONS = false;
    public static double INVESTMENT_CUTOFF_LEVEL = 0.02;  // 0.02 seems to work well
    public static boolean SUBSAMPLE_PARAMETERS = false;
    public static boolean TRUE_BOOTSTRAP = false; // as opposed to subsampling
    public static int SUBSAMPLE_SIZE = 19; // 19;  // 21 would be the maximum
    /**
     * Production parameters
     */
    public static boolean USE_LATE_PERIOD_PRODUCTION_COST_SHIFTERS = false;
    public static boolean USE_MR_MC_CONDITION = false;
    public static boolean IGNORE_CAPACITY_COSTS = false;

    // production parameters
    public static boolean USE_CA_SHIFTER = false;
    public static boolean USE_STATE_FIXED_EFFECTS = true;

    // 2nd-stage simulation parameters
    public static int NUM_SIMW = 1500;  // have been using 1500
    /**
     * This next boolean tells the program to estimate the dynamic parameters
     * as if it were the early period.  This is used in simulateW.java.  The idea
     * for this switch is to constrain the estimates of the dynamic parameters
     * to be the same across the two periods.  We let the difference between
     * the two be expressed in entry costs.
     *
     * SHOULD ONLY BE USED WITH LATE_PERIOD!
     */
    public static boolean FORCE_EARLY_DYNAMIC_PARAMETERS = true;
    /**
     * Years to use data
     */
    public static int START_YEAR = 1980;
    public static int END_YEAR = 1998;
}
