/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package simulation.mpneSolver;

import Jama.Matrix;
import simulation.mpneSimulation.utility.simulationPrimitives;

/**
 *
 * @author Stephen P. Ryan
 */
public class SimulationResults {

    private double averageProducerProfit;
    private Jama.Matrix profitVector;
    private double averageSizeOverall;
    private double marketSizeOverall;
    private double quantityProduced;
    private double averagePrice;
    private double averagePriceEmissions;
    private double averageEmissions;
    private double simCS;
    private double simCarbon;
    private double simEmissions;
    private double nofirms;
    private double onefirm;
    private double twofirms;
    private double threefirms;
    private double fourfirms;
    private double fivefirms;
    private double sixfirms;
    private Matrix W;

    public SimulationResults(double averageProducerProfit, Matrix profitVector,
            double averageSizeOverall, double marketSizeOverall, double quantityProduced, double averagePrice, double averagePriceEmissions,
            double averageEmissions, double simCS, double simCarbon, double simEmissions, double nofirms, double onefirm, double twofirms, double threefirms,
            double fourfirms, double fivefirms, double sixfirms, Jama.Matrix W) {
        this.averageProducerProfit = averageProducerProfit;
        this.profitVector = profitVector;
        this.averageSizeOverall = averageSizeOverall;
        this.marketSizeOverall = marketSizeOverall;
        this.quantityProduced = quantityProduced;
        this.averagePrice = averagePrice;
        this.averagePriceEmissions = averagePriceEmissions;
        this.averageEmissions = averageEmissions;
        this.simCS = simCS;
        this.simCarbon = simCarbon;
        this.simEmissions = simEmissions;
        this.nofirms = nofirms;
        this.onefirm = onefirm;
        this.twofirms = twofirms;
        this.threefirms = threefirms;
        this.fourfirms = fourfirms;
        this.fivefirms = fivefirms;
        this.sixfirms = sixfirms;
        this.W = W;
    }

    @Override
    public String toString() {
        return "Profit: "+averageProducerProfit+"\n"+
                "Average Size: "+averageSizeOverall+"\n"+
                "Market size: "+marketSizeOverall+"\n"+
                "Quantity: "+quantityProduced+"\n"+
                "Price: "+averagePrice+"\n"+
                "Consumer Surplus: "+simCS;
    }

    public double getTotalWelfare() {
        return averageProducerProfit*simulationPrimitives.NUM_FIRMS + simCarbon + simCS;
    }

    public double getProfitFirm1() {
        return profitVector.get(0, 0);
    }

    /**
     * @return the averageProducerProfit
     */
    public double getAverageProducerProfit() {
        return averageProducerProfit;
    }

    /**
     * @return the profitVector
     */
    public Jama.Matrix getProfitVector() {
        return profitVector;
    }

    /**
     * @return the averageSizeOverall
     */
    public double getAverageSizeOverall() {
        return averageSizeOverall;
    }

    /**
     * @return the marketSizeOverall
     */
    public double getMarketSizeOverall() {
        return marketSizeOverall;
    }

    /**
     * @return the quantityProduced
     */
    public double getQuantityProduced() {
        return quantityProduced;
    }

    /**
     * @return the averagePrice
     */
    public double getAveragePrice() {
        return averagePrice;
    }

    /**
     * @return the averagePriceEmissions
     */
    public double getAveragePriceEmissions() {
        return averagePriceEmissions;
    }

    /**
     * @return the averageEmissions
     */
    public double getAverageEmissions() {
        return averageEmissions;
    }

    /**
     * @return the simCS
     */
    public double getSimCS() {
        return simCS;
    }

    /**
     * @return the simCarbon
     */
    public double getSimCarbon() {
        return simCarbon;
    }

    /**
     * @return the simEmissions
     */
    public double getSimEmissions() {
        return simEmissions;
    }

    /**
     * @return the nofirms
     */
    public double getNofirms() {
        return nofirms;
    }

    /**
     * @return the onefirm
     */
    public double getOnefirm() {
        return onefirm;
    }

    /**
     * @return the twofirms
     */
    public double getTwofirms() {
        return twofirms;
    }

    /**
     * @return the threefirms
     */
    public double getThreefirms() {
        return threefirms;
    }

    /**
     * @return the fourfirms
     */
    public double getFourfirms() {
        return fourfirms;
    }

    /**
     * @return the fivefirms
     */
    public double getFivefirms() {
        return fivefirms;
    }

    /**
     * @return the sixfirms
     */
    public double getSixfirms() {
        return sixfirms;
    }

    /**
     * @return the W
     */
    public Matrix getW() {
        return W;
    }
}
